﻿BasicGridClass = function() {
	return {
		init : function() {
			//데이타 스토어 정의
			this.store = new Ext.data.Store({
				proxy: new Ext.data.HttpProxy({
					url:'basicGrid.json'
				}),
				sortInfo : {
					field : 'price',
					direction : "DESC"
				},
				reader: new Ext.data.JsonReader(
					{ root: 'testData'  },
					[
						{name: 'company', type:'string', mapping: 'company'},
						{name: 'price', type: 'float', mapping: 'price'},
						{name: 'change', type: 'float', mapping: 'change'},
						{name: 'pctChange', type: 'float', mapping: 'pctChange'},
						{name: 'lastChange', type: 'date', dateFormat: 'n/j h:ia', mapping: 'lastChange'}
					]
				)
			});
			this.grid = new Ext.grid.GridPanel({
				store: this.store,
				columns: [
					{id:'company',header: "Company", width: 160, sortable: true, dataIndex: 'company' },
					{header: "Price", width: 75, sortable: true, renderer: 'usMoney', dataIndex: 'price' },
					{header: "Change", width: 75, sortable: true, dataIndex: 'change'},
					{header: "% Change", width: 75, sortable: true, dataIndex: 'pctChange'},
					{header: "Last Updated", width: 85, sortable: true, renderer: Ext.util.Format.dateRenderer('m/d/Y'), dataIndex: 'lastChange'}
				],
				stripeRows: true,
				autoExpandColumn: 'company',
				loadMask: {msg:'데이타 로드중'},
				sm: new Ext.grid.RowSelectionModel({
					singleSelect:true
				}),
				view: new Ext.grid.GridView({
					forceFit:true,
					enableRowBody:true,
					emptyText: 'No Record found'
				}),
				height:350,
				width:800,
				title:'기본 그리드'
			});

			this.grid.render('DIV_GRID_HERE');
			this.store.load();
			this.gsm = this.grid.getSelectionModel();
			this.store.on('load', this.gsm.selectFirstRow, this.gsm);
			

			this.grid.on('rowcontextmenu', this.getRowData, this);
			this.grid.on('rowclick', this.getRowData, this);
			this.grid.on('rowdblclick', this.getRowData, this);
			this.gsm.on('rowselect', this.rowSelect,this);
		},

		getRowData : function(thisGrid, rowIndex, eventObject){
		        var record = this.store.getAt(rowIndex) || this.gsm.getSelected();
		        alert(record.data.company+'\n'+ record.get('company'));
		},

		rowSelect:function(selectionModel, index, record){ 
			alert(record.data.company+'\n'+ record.get('company'));
		}

	}
}();
Ext.EventManager.onDocumentReady(BasicGridClass.init, BasicGridClass, true);